# Metrictank Public Community Call

We host a public community call on the last Wednesday of every month at 16:00 (UTC). You can view the schedule of upcoming calls on the [community calendar][calendar], as well as other Metrictank related events.

***NOTE***

These calls are recorded. If you do not wish to be recorded, you are free to disable your audio and/or video feed, or to join under a pseudonym. We will publish and link the recordings from this document so you can consume them anonymously if you prefer.

## General Information

Agenda: The agenda can be found in the [community calendar][calendar] entry for each month

Zoom Call Link: [https://zoom.us/j/636994029][zoom]

## Why?

We want to provide a monthly summary of all things Metrictank: major bug fixes, breaking changes, upcoming events, and a place to discuss the future of the project.

## Code of Conduct

All participants are expected to follow the [Metrictank Code Of Conduct][coc]. Please let us know if you encounter any violations of the Code of Conduct at conduct@grafana.com

## Typical Agenda Outline

Greetings / Host Introduction

Announcements

* Major Updates
* Breaking Changes
* Events

Questions

Discussions / Demos

## Notes For Presenters

* Out of respect for everyone’s time, we ask that you be fully prepared for your announcement. Make sure slides are clear if applicable, and the link to them is posted in the meeting agenda.
* Your announcement should provide clear, valuable information to the community without being commercial in nature. Typical sales pitches are not permitted, and could potentially alienate your audience.
* You are required to show up 10 minutes before the meeting to verify your audio and screensharing capabilities with the hosts. If you cannot make and keep this commitment, you will not be allowed to proceed with your announcement until such time as you can.
* You are also required to commit to being available the week before your announcement date in case there is an issue with that week's announcement.
* The use of a headset or other high-quality audio equipment is strongly encouraged. Typing on a laptop while using the system microphone is distracting, so please insulate your microphone from key noises.
* Ensure you are presenting from a quiet environment.
* If you run out of time while performing your announcement, you may ask the audience if they would like a follow-up at a subsequent meeting. If there is enthusiastic support, the community team will help schedule a continuation.

[coc]: https://github.com/grafana/grafana/blob/master/CODE_OF_CONDUCT.md
[calendar]: https://calendar.google.com/calendar/embed?src=grafana.com_n57lluqpn4h4edroeje6199o00%40group.calendar.google.com
[zoom]: https://zoom.us/j/636994029
